// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{ffi, LaunchableKind};
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "AsLaunchable")]
    pub struct Launchable(Object<ffi::AsLaunchable, ffi::AsLaunchableClass>);

    match fn {
        type_ => || ffi::as_launchable_get_type(),
    }
}

impl Launchable {
    pub const NONE: Option<&'static Launchable> = None;

    #[doc(alias = "as_launchable_new")]
    pub fn new() -> Launchable {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::as_launchable_new()) }
    }
}

impl Default for Launchable {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Launchable>> Sealed for T {}
}

pub trait LaunchableExt: IsA<Launchable> + sealed::Sealed + 'static {
    #[doc(alias = "as_launchable_add_entry")]
    fn add_entry(&self, entry: &str) {
        unsafe {
            ffi::as_launchable_add_entry(self.as_ref().to_glib_none().0, entry.to_glib_none().0);
        }
    }

    #[doc(alias = "as_launchable_get_entries")]
    #[doc(alias = "get_entries")]
    fn entries(&self) -> Vec<glib::GString> {
        unsafe {
            FromGlibPtrContainer::from_glib_none(ffi::as_launchable_get_entries(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_launchable_get_kind")]
    #[doc(alias = "get_kind")]
    fn kind(&self) -> LaunchableKind {
        unsafe { from_glib(ffi::as_launchable_get_kind(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_launchable_set_kind")]
    fn set_kind(&self, kind: LaunchableKind) {
        unsafe {
            ffi::as_launchable_set_kind(self.as_ref().to_glib_none().0, kind.into_glib());
        }
    }
}

impl<O: IsA<Launchable>> LaunchableExt for O {}
